unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, shellapi, Menus;

type
  TFrmPrincipal = class(TForm)
    Panel2: TPanel;
    Lista: TListBox;
    Panel3: TPanel;
    Splitter1: TSplitter;
    Button2: TButton;
    Button3: TButton;
    Button1: TButton;
    LAviso: TPanel;
    PopupMenu1: TPopupMenu;
    Instalar1: TMenuItem;
    Informacin1: TMenuItem;
    N1: TMenuItem;
    Cerrar1: TMenuItem;
    Panel1: TPanel;
    LWEB: TLabel;
    Label1: TLabel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListaDblClick(Sender: TObject);
    procedure ListaKeyPress(Sender: TObject; var Key: Char);
    procedure Cerrar1Click(Sender: TObject);
    procedure Informacin1Click(Sender: TObject);
    procedure Instalar1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmPrincipal: TFrmPrincipal;

implementation

uses UnidadInformacion;

{$R *.DFM}

procedure TFrmPrincipal.SpeedButton1Click(Sender: TObject);
begin
  close;
end;

procedure TFrmPrincipal.Button1Click(Sender: TObject);
begin
  close;
end;

procedure TFrmPrincipal.Button2Click(Sender: TObject);
var
  fEjecutable, nombreCD, m, programa, info : string;
  terminar : boolean;
  txt : textfile;
begin
  if Lista.ItemIndex = -1 then
    Application.MessageBox ('Debe seleccionar un programa a instalar.',
        'Seleccin...', MB_ICONEXCLAMATION + MB_OK)
  else
  begin
    //WindowState := wsMinimized;
    AssignFile(Txt, extractfilepath(application.exename) + 'info.txt');
    Reset(Txt);
    readln(txt, nombreCD);  //Titulo del CD no nos hace falta
    terminar := false;
    while not terminar do
    begin
      readln(txt, programa);  //Nombre del programa
      if uppercase(programa) = uppercase(Lista.items[lista.ItemIndex]) then
      begin
        readln(txt, fEjecutable);  //fichero ejecutable y ruta
        ShellExecute(Handle, Nil, PChar(extractfilepath(application.exename) +
          fEjecutable),'', Nil, SW_NORMAL);
        closefile(txt);
        exit;
      end;
      readln(txt, fEjecutable);  //fichero ejecutable
      readln(txt, info); //Comentario no hace falta
      readln(txt, m); //marca de fin
      if uppercase(m) = 'FIN' then
        terminar := true;
    end;
    closefile(txt);
    Application.MessageBox ('No se ha encontrado en el fichero de instalacin de la aplicacin seleccionada.',
        'No se puede instalar...', MB_ICONEXCLAMATION + MB_OK)
  end;
end;

procedure TFrmPrincipal.Button3Click(Sender: TObject);
var
  info, nombreCD, m, fe, programa : string;
  terminar : boolean;
  txt : textfile;
begin
  if Lista.ItemIndex = -1 then
    Application.MessageBox ('Debe seleccionar un programa para mostrar informacin.',
        'Informacin...', MB_ICONEXCLAMATION + MB_OK)
  else
  begin
    application.createform(tforminformacion, forminformacion);
    AssignFile(Txt, extractfilepath(application.exename) + 'info.txt');
    Reset(Txt);
    readln(txt, nombreCD);  //Titulo del CD no nos hace falta
    terminar := false;
    while not terminar do
    begin
      readln(txt, programa);  //Nombre del programa
      if uppercase(programa) = uppercase(Lista.items[lista.ItemIndex]) then
      begin
        readln(txt, fe);  //fichero ejecutable no hace falta
        readln(txt, info); //Comentario
        closefile(txt);
        forminformacion.LTexto.Text := info;
        forminformacion.LNombre.Caption := 'CD: ' + nombreCD + ' -> Programa: ' + programa;
        forminformacion.showmodal;
        exit;
      end;
      readln(txt, fe);  //fichero ejecutable no hace falta
      readln(txt, info); //Comentario no hace falta
      readln(txt, m); //marca de fin
      if uppercase(m) = 'FIN' then
        terminar := true;
    end;
    closefile(txt);
    Application.MessageBox ('No se ha encontrado en el fichero de informacin de la aplicacin seleccionada.',
        'No se puede informar...', MB_ICONEXCLAMATION + MB_OK)
  end;
end;

procedure TFrmPrincipal.FormCreate(Sender: TObject);
var
  txt : textfile;
  titulo : string;
  nombreCD : string;
  terminar : boolean;
begin
  titulo := '';
  AssignFile(Txt, extractfilepath(application.exename) + 'info.txt');
  try
    Reset(Txt);
  except
    closefile(txt);
    Application.MessageBox (pchar('No existe el fichero de informacin: ' +
       chr(13) + chr(13) + extractfilepath(application.exename) + 'info.txt'),
        'Fichero no encontrado...', MB_ICONERROR + MB_OK);
    Application.Terminate;
    exit;
  end;
  readln(txt, titulo);
  if titulo = '' then
  begin
    closefile(txt);
    Application.MessageBox (pchar('El fichero de informacin est vaco: ' +
       chr(13) + chr(13) + extractfilepath(application.exename) + 'info.txt'),
        'Fichero vaco...', MB_ICONERROR + MB_OK);
    Application.Terminate;
  end;
  caption := 'CD/DVD: ' + titulo;
  Lista.Clear;
  terminar := false;
  while not terminar do
  begin
    readln(txt, nombreCD);  //titulo del CD
    lista.Items.Add (nombreCD);
    readln(txt, nombreCD);  //fichero ejecutable no hace falta ahora
    readln(txt, nombreCD); //Comentario no hace falta
    readln(txt, nombreCD); //marca de fin
    if uppercase(nombreCD) = 'FIN' then
      terminar := true;
  end;
  closefile(txt);  
end;

procedure TFrmPrincipal.ListaDblClick(Sender: TObject);
begin
  Button2Click(nil);
end;

procedure TFrmPrincipal.ListaKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
    Button2Click(nil);
end;

procedure TFrmPrincipal.Cerrar1Click(Sender: TObject);
begin
  Button1Click(nil);
end;

procedure TFrmPrincipal.Informacin1Click(Sender: TObject);
begin
  Button3Click(nil);
end;

procedure TFrmPrincipal.Instalar1Click(Sender: TObject);
begin
  Button2Click(nil);
end;

procedure TFrmPrincipal.FormShow(Sender: TObject);
begin
  lista.ItemIndex := 0;
end;

procedure TFrmPrincipal.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
